# ladestationen
API des Ladesäulenregisters der Bundesnetzagentur

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 1.0.0
- Package version: 1.0.5
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python >=3.6

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/bundesAPI/ladestationen-api.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/bundesAPI/ladestationen-api.git`)

Then import the package:
```python
from deutschland import ladestationen
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
from deutschland import ladestationen
```

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import time
from deutschland import ladestationen
from pprint import pprint
from deutschland.ladestationen.api import default_api
from deutschland.ladestationen.model.station_overview import StationOverview
# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = ladestationen.Configuration(
    host = "http://localhost"
)



# Enter a context with an instance of the API client
with ladestationen.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = default_api.DefaultApi(api_client)
    geometry = "geometry_example" # str | Geometry filter. URL-enkodiertes JSON Objekt vom Typ `Geometry`
out_fields = "*" # str | Auswahl der Felder, die ausgegeben werden sollen, durch Komma getrennt (default to "*")
geometry_type = "esriGeometryEnvelope" # str | Art der Geometry (optional) (default to "esriGeometryEnvelope")
f = "json" # str | Ausgabeformat der Daten. Default ist 'html'. (optional)
object_ids = "42,123,666" # str | Komma-separierte Liste von IDs (integer), filtert nach den einzelnen Objekten (optional)
order_by_fields = "orderByFields_example" # str |  (optional)
return_geometry = True # bool |  (optional)
spatial_rel = "esriSpatialRelIntersects" # str | Spatial Relationships (optional)
in_sr = 1 # int | Input Spatial Reference (optional)
out_sr = 1 # int | Output Spatial Reference (optional)
max_record_count_factor = 1 # int |  (optional)
result_type = "none" # str |  (optional)
quantization_parameters = "quantizationParameters_example" # str | URL-enkodiertes JSON Objekt vom Typ `QuantizationParameter` (optional)
where = "where_example" # str | SQL \"where\" Filter (optional)
having = "having_example" # str |  (optional)
time = 1 # int |  (optional)
distance = "0.0" # str |  (optional)
units = "esriSRUnit_Meter" # str |  (optional)
geometry_precision = "geometryPrecision_example" # str |  (optional)
feature_encoding = "esriDefault" # str |  (optional)
group_by_fields_for_statistics = "groupByFieldsForStatistics_example" # str |  (optional)
cache_hint = True # bool |  (optional)
return_extent_only = True # bool |  (optional)
return_z = True # bool |  (optional)
return_ids_only = True # bool |  (optional)
return_centroid = True # bool |  (optional)
return_exceeded_limit_features = True # bool |  (optional)
datum_transformation = "datumTransformation_example" # str |  (optional)
result_offset = "resultOffset_example" # str |  (optional)
apply_vcs_projection = True # bool |  (optional)
out_statistics = "outStatistics_example" # str |  (optional)
return_distinct_values = True # bool |  (optional)
multipatch_option = "none" # str |  (optional)
return_m = True # bool |  (optional)
max_allowable_offset = 1 # int |  (optional)
return_count_only = True # bool |  (optional)
return_unique_ids_only = True # bool |  (optional)
return_query_geometry = True # bool |  (optional)
result_record_count = 1 # int |  (optional)
sql_format = "none" # str |  (optional)
token = "token_example" # str |  (optional)
return_geodetic = True # bool |  (optional)

    try:
        # Query für alle Ladesäulen
        api_response = api_instance.query_get(geometry, out_fields, geometry_type=geometry_type, f=f, object_ids=object_ids, order_by_fields=order_by_fields, return_geometry=return_geometry, spatial_rel=spatial_rel, in_sr=in_sr, out_sr=out_sr, max_record_count_factor=max_record_count_factor, result_type=result_type, quantization_parameters=quantization_parameters, where=where, having=having, time=time, distance=distance, units=units, geometry_precision=geometry_precision, feature_encoding=feature_encoding, group_by_fields_for_statistics=group_by_fields_for_statistics, cache_hint=cache_hint, return_extent_only=return_extent_only, return_z=return_z, return_ids_only=return_ids_only, return_centroid=return_centroid, return_exceeded_limit_features=return_exceeded_limit_features, datum_transformation=datum_transformation, result_offset=result_offset, apply_vcs_projection=apply_vcs_projection, out_statistics=out_statistics, return_distinct_values=return_distinct_values, multipatch_option=multipatch_option, return_m=return_m, max_allowable_offset=max_allowable_offset, return_count_only=return_count_only, return_unique_ids_only=return_unique_ids_only, return_query_geometry=return_query_geometry, result_record_count=result_record_count, sql_format=sql_format, token=token, return_geodetic=return_geodetic)
        pprint(api_response)
    except ladestationen.ApiException as e:
        print("Exception when calling DefaultApi->query_get: %s\n" % e)
```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*DefaultApi* | [**query_get**](docs/DefaultApi.md#query_get) | **GET** /query | Query für alle Ladesäulen


## Documentation For Models

 - [Geometry](docs/Geometry.md)
 - [QuantizationParameter](docs/QuantizationParameter.md)
 - [StationOverview](docs/StationOverview.md)
 - [StationOverviewAttributes](docs/StationOverviewAttributes.md)
 - [StationOverviewFeatures](docs/StationOverviewFeatures.md)
 - [StationOverviewFields](docs/StationOverviewFields.md)
 - [StationOverviewSpatialReference](docs/StationOverviewSpatialReference.md)
 - [StationOverviewTransform](docs/StationOverviewTransform.md)
 - [StationOverviewUniqueIdField](docs/StationOverviewUniqueIdField.md)


## Documentation For Authorization

 All endpoints do not require authorization.

## Author

kontakt@bund.dev


## Notes for Large OpenAPI documents
If the OpenAPI document is large, imports in ladestationen.apis and ladestationen.models may fail with a
RecursionError indicating the maximum recursion limit has been exceeded. In that case, there are a couple of solutions:

Solution 1:
Use specific imports for apis and models like:
- `from deutschland.ladestationen.api.default_api import DefaultApi`
- `from deutschland.ladestationen.model.pet import Pet`

Solution 2:
Before importing the package, adjust the maximum recursion limit as shown below:
```
import sys
sys.setrecursionlimit(1500)
from deutschland import ladestationen
from deutschland.ladestationen.apis import *
from deutschland.ladestationen.models import *
```

